<script setup>
import {onMounted, ref} from "vue";
import {
  genericError,
  myAlert,
  workshopsMax,
  workshopsMe,
  workshopsRegister,
  workshopsUnregister
} from "@/common/ServerAPI.js";

const workshopsMeR = ref([]);
const workshopsMaxR = ref([]);

function refresh() {
  workshops.value = [];
  workshopsMeR.value = [];
  workshopsMaxR.value = [];
  workshopsMe(responseMe => {
    workshopsMeR.value = JSON.parse(responseMe);
    workshopsMax(responseMax => {
      workshopsMaxR.value = JSON.parse(responseMax);
      workshops.value = workshopsResp;
    });
  });
}

onMounted(() => {
  refresh();
});

function register(id) {
  workshopsRegister(id, response => {
    if (response === "SUCCESS") {
      myAlert("Inscrit au workshop");
      refresh();
    } else {
      genericError();
      refresh();
    }
  })
}

function unregister(id) {
  workshopsUnregister(id, response => {
    if (response === "SUCCESS") {
      myAlert("Désinscrit au workshop");
      refresh();
    } else {
      genericError();
      refresh();
    }
  })
}

const workshopsResp = [
  {
    "id": "ws_PolympiadesMath",
    "association": "Polympiades",
    "name": "Initiation aux olympiades de mathématiques",
    "places": "limited"
  },
  {
    "id": "ws_PolympiadesProg",
    "association": "Polympiades",
    "name": "Initiation à la programmation compétitive",
    "places": "limited"
  },
  {
    "id": "ws_iGem",
    "association": "iGem",
    "name": "Introduction to Synthetic Biology",
    "places": "limited"
  },
  {
    "id": "ws_CLIC",
    "association": "CLIC",
    "name": "L’IA, la découverte concrète",
    "places": "unlimited"
  },
  {
    "id": "ws_CLICGAME",
    "association": "CLIC - GAME*",
    "name": "Atelier Speedrun",
    "places": "unlimited"
  },
  {
    "id": "ws_XploreFormationMecanique",
    "association": "Xplore",
    "name": "Formation Mécanique",
    "places": "unlimited"
  }, {
    "id": "ws_XploreFormationElectronique",
    "association": "Xplore",
    "name": "Formation Électronique",
    "places": "unlimited"
  },
  {
    "association": "Xplore",
    "name": "Présentation MAKE & EPFL Xplore",
    "places": "unlimited"
  },
  {
    "id": "ws_XploreLesLimitesdeletreHumain",
    "association": "Loic (*plus Xplore)",
    "name": "Les Limites de l’Etre Humain",
    "places": "unlimited"
  },
  {
    "id": "ws_ApprendreaetudierRolex",
    "association": "ROLEX",
    "name": "Apprendre à utiliser l’information scientifique",
    "places": "limited"
  },
  {
    "id": "ws_ThomasKVendredi30",
    "association": "Thomas K",
    "name": "Le vendredi 30 - Apprendre à la vitesse de l’éclair (même si t’as la flemme)",
    "places": "unlimited"
  },
  {
    "id": "ws_ThomasKJeudi5",
    "association": "Thomas K",
    "name": "Le jeudi 5 - Apprendre à la vitesse de l’éclair (même si t’as la flemme)",
    "places": "unlimited"
  },
  {
    "id": "ws_SPOTAtrium14ha16h",
    "association": "SPOT & MAKE",
    "name": "Présentation des projets MAKE et visite du SPOT - 14h à 16h",
    "places": "limited"
  },
  {
    "id": "ws_SPOTAtrium16ha18h",
    "association": "SPOT & MAKE",
    "name": "Présentation des projets MAKE et visite du SPOT - 16h à 18h",
    "places": "limited"
  },
  {
    "id": "ws_ZEG",
    "association": "ZEG",
    "name": "Fresque du Climat",
    "places": "unlimited"
  },
  {
    "id": "ws_Tania",
    "association": "Tania LAFORE",
    "name": " - ",
    "places": "unlimited"
  },
  {
    "id": "ws_Arcanite",
    "association": "Arcanite",
    "name": "Arcanite vous aide",
    "places": "unlimited"
  },
  {
    "id": "ws_BioSense",
    "association": "BioSense",
    "name": "Biocapteurs à l’EPFL",
    "places": "unlimited"
  },
  {
    "id": "ws_JDRleJeudi29",
    "association": "JDR",
    "name": "Le jeudi 29 - Jeux de rôle et de société (pas jeux de rôles ce jour)",
    "places": "unlimited"
  },
  {
    "id": "ws_JDRleMardi3",
    "association": "JDR",
    "name": "Le mardi 3 - Jeux de rôle et de société (pour jeux de société)",
    "places": "unlimited",
  },
  {
    "id": "ws_JDRleMardi3Mail",
    "association": "JDR",
    "name": "le mardi 3 - Jeux de rôle et de société (pour jeux de rôles)",
    "places": "limited",
    "message": "Contactez eve@jdrpoly.ch"
  },
  {
    "association": "LudoPoly",
    "name": "Jeux de société"
  },
  {
    "association": "GNU-Gen",
    "name": "Introduction à Git"
  },
  {
    "association": "PJ",
    "name": "Projection animation japonaise"
  },
  {
    "association": "Students 4 Students",
    "name": "Orientation, présentation des sections"
  },
  {
    "association": "E-Bou",
    "name": "Viens passer un moment fun avec Ebou"
  },
];

const workshops = ref();

</script>

<template>
  <!--  Le titre-->
  <div>
    <ul class="flex flex-col text-center space-y space-y-4 text-sm font-medium text-white mb-4 md:mt-20">
      <h2
          class="text-2xl font-extrabold  max-w-screen-xl flex flex-wrap items-center justify-between mx-auto p-4 mb-6">
        Inscription aux Workshops</h2>
    </ul>
  </div>
  <!--  Pour afficher des infos-->

<!--  <div class="flex justify-center mb-6">-->
<!--    <div class="flex items-center justify-center w-1/2 p-4 mb-4 text-sm text-blue-800 rounded-lg bg-s4s-redwood-400"-->
<!--         role="alert">-->
<!--      <svg class="flex-shrink-0 inline w-4 h-4 me-3" aria-hidden="true" xmlns="http://www.w3.org/2000/svg"-->
<!--           fill="currentColor" viewBox="0 0 20 20">-->
<!--        <path-->
<!--            d="M10 .5a9.5 9.5 0 1 0 9.5 9.5A9.51 9.51 0 0 0 10 .5ZM9.5 4a1.5 1.5 0 1 1 0 3 1.5 1.5 0 0 1 0-3ZM12 15H8a1 1 0 0 1 0-2h1v-3H8a1 1 0 0 1 0-2h2a1 1 0 0 1 1 1v4h1a1 1 0 0 1 0 2Z"/>-->
<!--      </svg>-->
<!--      <span class="sr-only">Info</span>-->
<!--      <div>-->
<!--        <span class="font-medium">Les inscriptions aux workshops s'afficheront ici</span>-->
<!--      </div>-->
<!--    </div>-->
<!--  </div>-->
  <div class="flex justify-center mb-6">
    <div class="flex items-center justify-center w-1/2 p-4 mb-4 text-sm text-blue-800 rounded-lg bg-s4s-redwood-400"
         role="alert">
      <svg class="flex-shrink-0 inline w-4 h-4 me-3" aria-hidden="true" xmlns="http://www.w3.org/2000/svg"
           fill="currentColor" viewBox="0 0 20 20">
        <path
            d="M10 .5a9.5 9.5 0 1 0 9.5 9.5A9.51 9.51 0 0 0 10 .5ZM9.5 4a1.5 1.5 0 1 1 0 3 1.5 1.5 0 0 1 0-3ZM12 15H8a1 1 0 0 1 0-2h1v-3H8a1 1 0 0 1 0-2h2a1 1 0 0 1 1 1v4h1a1 1 0 0 1 0 2Z"/>
      </svg>
      <span class="sr-only">Info</span>
      <div>
                <span class="font-medium">Pas besoin de s'inscrire pour les workshops à entrée libre. Venez librement.</span>
      </div>
    </div>
  </div>
  <br>
  <div class="relative flex md:justify-center overflow-x-auto sm:overflow-x-visible w-full">
      <table class="text-sm text-center rtl:text-right rounded-md">
        <thead class="text-xs text-gray-700 uppercase bg-s4s-purple-900 text-white  ">
        <tr>
          <th scope="col" class="px-6 py-3">
            Association
          </th>
          <th scope="col" class="px-6 py-3">
            Nom
          </th>
          <th scope="col" class="px-6 py-3">
            Places
          </th>
          <th scope="col" class="px-6 py-3">
            Inscription
          </th>
        </tr>
        </thead>
        <tr class="bg-s4s-redwood-600 border-b hover:bg-gray-50" v-for="workshop in workshops">
          <th class="px-6 py-4 font-medium w-1/2" style="min-width: max-content">
            <div class="ps-3">
              <div class="font-semibold">{{ workshop.association }}</div>
            </div>
          </th>
          <th class="px-6 py-4 font-medium w-1/2" style="min-width: max-content">
            <div class="ps-3">
              <div class="font-semibold">{{ workshop.name }}</div>
            </div>
          </th>
          <td class="px-6 py-4" style="min-width: max-content">
            <div class="ps-3" v-if="!workshop.id" style="min-width: max-content">
              <div style="color: yellowgreen">entrée libre</div>
            </div>
            <div class="ps-3" v-if="workshop.id">
              <div v-if="workshop.places === 'limited' && workshopsMaxR[workshop.id]" style="color: darkcyan">limitées
              </div>
              <div v-if="workshop.places === 'unlimited' && workshopsMaxR[workshop.id]" style="color: green">
                illimitées
              </div>
              <div v-if="!workshopsMaxR[workshop.id]" style="color: darkred">plein</div>
            </div>
          </td>
          <td class="px-6 py-4" style="min-width: max-content">
            <div class="ps-3" v-if="!workshop.id" style="min-width: max-content">
              <button class="pl-4 pr-4 p-2 text-white rounded-md cursor-not-allowed" disabled
                      style="background-color: darkgreen;"
                      v-if="!workshopsMeR.includes(workshop.id) && !workshopsMaxR[workshop.id]  && !workshop.message">
                Entrée libre
              </button>
            </div>
            <div class="ps-3" v-if="workshop.id" style="min-width: max-content">
              <!--              <button class="bg-s4s-purple-800 pl-4 pr-4 p-2 text-white rounded-md" disabled v-if="!workshop.registred && workshop.places !== 'full'">Indisponible</button>-->
              <button class="bg-s4s-purple-300 pl-4 pr-4 p-2 text-white rounded-md cursor-not-allowed" disabled
                      v-if="!workshopsMeR.includes(workshop.id) && !workshopsMaxR[workshop.id]  && !workshop.message">
                Indisponible
              </button>
<!--              <button class="pl-4 pr-4 p-2 rounded-md cursor-not-allowed" disabled-->
<!--                      style="background-color: darkseagreen"-->
<!--                      v-if="workshopsMeR.includes(workshop.id)">Inscrit ✅-->
<!--              </button>-->
              <button class="bg-s4s-purple-800 pl-4 pr-4 p-2 text-white rounded-md"
                      @click="register(workshop.id)"
                      v-if="!workshopsMeR.includes(workshop.id) && workshopsMaxR[workshop.id] && !workshop.message ">
                S'inscrire
              </button>
                            <button class="bg-s4s-redwood-900 pl-4 pr-4 p-2 text-white rounded-md"
                                    @click="unregister(workshop.id)"
                                    v-if="workshopsMeR.includes(workshop.id) && !workshop.message">Se désinscrire
                            </button>
              <a class="pl-4 pr-4 p-2 text-white rounded-md"
                 v-if="workshop.message" style="color: darkred; min-width: max-content">{{ workshop.message }}</a>
            </div>
          </td>
        </tr>
      </table>
  </div>
</template>

<style scoped>
</style>
